//------------------------------------------------------------
/// \file	Main.cpp
/// \author	Rob Bateman
/// \date	9-feb-2005
/// \brief	A simple example of how to save a screenshot as a 
///			TGA file. 
//------------------------------------------------------------

#include <stdlib.h>
#include <GL/glut.h>
#include "screengrab.h"



//------------------------------------------------------------	Reshape()
void Reshape(int w, int h)
{
	if (h==0) {
		h=1;
	}
	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45,(float)w/h,0.1,100);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

//------------------------------------------------------------	Draw()
//
void Draw() {

	glClear(GL_DEPTH_BUFFER_BIT|GL_COLOR_BUFFER_BIT);

	glLoadIdentity();
	gluLookAt(1,2,6,0,0,0,0,1,0);

	glutSolidTeapot(1);

	glutSwapBuffers();
}

//------------------------------------------------------------	KeyDown()
void KeyDown(unsigned char k, int x, int y)
{
	// take a screen shot when s is pressed
	if(k=='s')
		SaveScreenGrab("screenshot.tga");
}



//------------------------------------------------------------	main()
//
int main(int argc,char** argv) {



	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DEPTH|GLUT_RGBA|GLUT_DOUBLE);
	glutInitWindowSize(640,480);
	glutCreateWindow("*** PRESS 's' TO GRAB SCREENSHOT ***");

	glutDisplayFunc(Draw);
	glutReshapeFunc(Reshape);
	glutKeyboardUpFunc(KeyDown);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_DEPTH_TEST);

	glutMainLoop();
	return 0;
}
