//-------------------------------------------------------------
/// \file	screengrab.cpp
/// \author	Rob Bateman
/// \date	9-feb-2005
/// \brief	some code to take a screen grab of an opengl window.
//-------------------------------------------------------------

#include "screengrab.h"
#include "tgasave.h"
#include <GL/glut.h>

bool SaveScreenGrab(const char* filename) {

	// get some info about the screen size
	unsigned sw      =  glutGet(GLUT_WINDOW_WIDTH);
	unsigned sh      =  glutGet(GLUT_WINDOW_HEIGHT);
	unsigned bpp     =  glutGet(GLUT_WINDOW_RGBA) ? 4 : 3;
	GLenum   format  =  (bpp==4) ? GL_RGBA : GL_RGB;


	// allocate memory to store image data
	unsigned char* pdata = new unsigned char[sw*sh*bpp];

	// read from front buffer
	glReadBuffer(GL_FRONT);

	// read pixel data
	glReadPixels(0,0,sw,sh,format,GL_UNSIGNED_BYTE,pdata);

	// write data as a tga file
	bool ret = WriteTga(filename,sw,sh,bpp,pdata);

	// clean up
	delete [] pdata;

	// done
	return ret;
}

